-- # Annotations
struct annotation(apos,acomment, textPos, textNode, pointNode, lineNode)	

callbacks.removeScripts id:#RateItTools	
try(destroyDialog rlt_annotation)catch()
	
function distanceFromSurface surfRay distance =
(
	-- Renvoie le point  *distance* de l'origine du ray surfRay
	(surfRay.pos+(surfRay.dir*distance)) 
)

function updateRateItAnnotations =
(
	for annotation in rateItAnnotations where (isValidNode annotation.textNode) do 
-- 		annotation.textNode.rotation.controller.Update()	
	(
		ntm = annotation.textNode.transform
		vtm = getViewTM()
		annotation.textNode.transform = translate (rotate (scalematrix ntm.scale) (inverse vtm.rotation)) ntm.pos
	)
	
-- 	in coordsys local (annotation.textNode.rotation=(inverse (viewport.GetTM()).rotationpart))
)

function deleteAllAnnotations =
(
	deleteLayer "RATE_IT_ANNOTATIONS"
)

function createBillboardText _text:"Billboard Text" _pos:[0,0,0] _size:100=
(	
	-- Creation du texte
	currText = text text:_text wirecolor:white pos:_pos size:_size
	addmodifier currText (uvwmap()) -- Pour le rendre plein
	RateItLayer = (layerManager.getLayerFromName "RATE_IT_ANNOTATIONS")
	RateItLayer.addnode currText

	currText
)

function averageDimensions _node =
(
	xpan = _node.max.x - _node.min.x
	ypan = _node.max.y - _node.min.y
	zpan = _node.max.z - _node.min.z
	
	average = (xpan+ypan+zpan) / 3
)

function createLine pointA pointB =
(
	_line = splineShape pos: pointA wirecolor:red
	addNewSpline _line
	addknot _line 1 #corner #line pointA
	addknot _line 1 #corner #line pointB
	updateShape _line
	
	RateItLayer = (layerManager.getLayerFromName "RATE_IT_ANNOTATIONS")
	RateItLayer.addnode _line
	
	_line
)

function getIntersectNodeMouse _node =
(
	if (isValidNode _node) then
	(
		mouseray = mapScreenToWorldRay mouse.pos 

		_intersection = (intersectRay _node mouseray)
		if _intersection != undefined then return _intersection
	)
	else (throw "getIntersectNodeMouse invalid _node")
)

function addAnnotationComment =
	createDialog rlt_annotation 300 70 200 200

function addAnnotation _ray _text _distance=
(
	if _ray != undefined then
	(
		textPos = distanceFromSurface _ray _distance
		
		newAnnotation = annotation apos:_ray.pos acomment:_text
		append rateItAnnotations newAnnotation
		_point = point pos:newAnnotation.apos box:off cross:on axistripod:off drawontop:on size:((averageDimensions currentObject)/100) wirecolor:red
		newAnnotation.pointNode = _point
		newAnnotation.textNode = (createBillboardText _text:_text _pos:textPos _size:((averageDimensions currentObject)/(annotationDistance*20)))
		newAnnotation.lineNode = createLine _point.pos newAnnotation.textNode.pos
		
		RateItLayer = (layerManager.getLayerFromName "RATE_IT_ANNOTATIONS")
		RateItLayer.addnode _point
	)
	else (throw "addAnnotation:_ray is undefined")		
)

tool onMouseClick
(
	on mousepoint clickno do
		if clickno == 1 then 
		(
			currentAnnotationRay = getIntersectNodeMouse currentObject
			if (currentAnnotationRay != undefined) then 
				addAnnotationComment()
		)
		else #stop
)

function AnnotationMode state =
(
	case state of
	(
		true: 	startTool onMouseClick
		false: 	stopTool onMouseClick
	)	
)

rollout rlt_annotation "Add Annotation" width:300 height:70
(
	edittext edt_comment "" pos:[7,25] width:240 height:32
	GroupBox grp1 "Annotation" pos:[5,5] width:290 height:58
	button btn_addAnnotation "Add" pos:[250,26] width:40 height:30

	on btn_addAnnotation pressed do
	(
		currentAnnotation = addAnnotation currentAnnotationRay edt_comment.text ((averageDimensions currentObject)/annotationDistance)
		destroyDialog rlt_annotation
		startTool onMouseClick
	)
)

mapped function deleteLayer _layer =
(
	-- accepts both layers indices and names
	case classOf _layer of
	(
		Integer:layer = layerManager.getLayer _layer
		String:layer = layerManager.getLayerFromName _layer
	)

	if layer != undefined then
	(
		if (layer.nodes &_nodes) and (layer.name != "0") and (_nodes.count > 0) do delete _nodes	
		(layerManager.getLayer 0).current = true
		layerManager.deleteLayerByName (layer.name)
	)
)