-- # Display
function setBackgroundImage state=
(
	_background = (mediaFolder + "background.jpg")
	
	case state of
	(
		true:
		(			
			 if (doesFileExist _background) then
			(
				_bgBitmap = openBitMap  _background
				setAsBackground _bgBitmap
				InvalidateAllBackgrounds()
				viewport.DispBkgImage = true
			)
		)
		
		false: 
		(
			backgroundImageFileName == "" 
			viewport.DispBkgImage = false
			completeRedraw()
		)
	)	
)

function superExpertMode bool =
(
	--set the trackbar visiblity to the new value:
	trackbar.visible = bool
	--set the time slider visiblity to the new value:
	timeSlider.setVisible bool
	--if true, exit the expert mode, if false, engage it:
	if (bool) then cui.expertModeOff() else cui.expertModeOn()
	cui.commandPanelOpen = bool
	--finally, set the status panel visibility:
	statusPanel.visible = bool
)

function setViewport =
(
	viewport.setLayout #layout_1
	viewport.setType #view_persp_user
	viewport.setGridVisibility #all false
	viewport.SetRenderLevel #smoothhighlights
)

function displayRollout _rollout =
(		
	_DesktopSizeX = sysInfo.DesktopSize[1]
	_DesktopSizeY = sysInfo.DesktopSize[2]
	posY = _DesktopSizeY - 130
	posX = _DesktopSizeX/2 - 225
	try (destroyDialog _rollout) catch()	
	_RateItRollout = rlt_RateIt
	createDialog _rollout 505 80 posX posY style:#(#style_sunkenedge)	
)

function toggleTextures state=
(
	case state of
	(
		true:displayColor.shaded = #materiale
		false:displayColor.shaded = #object 
	)
)	

function toggleShadingMode state=
(
	case state of
	(
		true:viewport.SetRenderLevel #smoothhighlights
		false:viewport.SetRenderLevel #wireframe
	)	
)

function toggleEdgeFaces state=
(
	case state of
	(
		true:viewport.SetShowEdgeFaces true
		false:viewport.SetShowEdgeFaces false
	)	
)
