-- # External file
function createFolder =
(
	evalFolder = (maxFilePath + "RateIt!\\")
	makeDir evalFolder
	theTime = getLocalTime()
	theTime = (theTime[1] as string) + "_" + (theTime[2] as string) + "_" + (theTime[4] as string) + "_" + (theTime[5] as string) + "h" + (theTime[6] as string)
	
	currentFolder =  evalFolder + "RateIt_" + theTime
	makedir currentFolder
)

function takeSnapshot =
(
	JPEG.setQuality 100
	i = 1
	_snapShot = gw.getViewportDib() 
	_filename = (currentFolder + "\\" + currentObject.name + "_" + (i as string))
	
	while doesFileExist (_filename + ".jpg") do 
	(
		_filename  = trimright _filename "0123456789"
		_filename  = trimright _filename "_"
		_filename = _filename + "_" + ((i+=1) as string)
	)
	_snapShot.filename = (_filename + ".jpg")
	save _snapShot 			
)	

function formatToHTML _htmlFile item index =
(
	rating = getuserprop item "RateItRating"
	validation = getuserprop item "RateItValidation"
	comments = getuserprop item "RateItComment"
	name = item.name	
	imgs = getFiles (currentFolder + "\\" + name + "*.jpg")
	
	format "<p><b>% - %</b></p>\n" index name to:_htmlFile
	-- parse the snapshots
	for img in imgs do
	(
		img = (filterstring img "\\")[(filterstring img "\\").count]
		format "<a href=\"%\"><img border=\"0\" src=\"%\" width=\"%\" height=\"%\"/></a>" img img snapShotRes[1] snapShotRes[2] to:_htmlFile
	)
	
	case validation of
	(
		"Accepted":	format 	"<p style=\"color:green\">		Evaluation : 	<b>%</b>            --           Rating : <b>%</b>/5</p>" validation rating to:_htmlFile
		"Rejected":		format 	"<p style=\"color:red\"> 		Evaluation :	<b>%</b>            --           Rating : <b>%</b>/5</p>" validation rating to:_htmlFile
		"undefined":	format 	"<p>							 		Evaluation : 	<b>%</b>            --           Rating : <b>%</b>/5</p>" validation rating to:_htmlFile
	)
	format "<p><b>Comments:</b></p>"  to:_htmlFile
	format "<p>%</p>" comments  to:_htmlFile
	format "<p>=================================================================================</p>" to:_htmlFile
)

function createReviewFile items=
(
	if maxfilepath != "" then
	(
		_htmlPath = (currentFolder + "\\RateIt_evaluation" + ".html") 
		 createFile _htmlPath
		_htmlFile = openFile _htmlPath mode:"a"
		
		format "<body bgcolor=\"9db5d5\" style=\"font-family:verdana\">"  to:_htmlFile
		format "<p>Evaluation of %</p>" (maxfilepath + maxfilename) to:_htmlFile
		format "<p><b>Objects :</b><br/>"  to:_htmlFile
		for item in items do format "% - %<br/>" item.name (getuserprop item "RateItValidation") to:_htmlFile
		format "</p>"  to:_htmlFile
		format "<p>=================================================================================</p>" to:_htmlFile
		
		for i = 1 to items.count do formatToHTML _htmlFile items[i] i 
		
		format "</body>"  to:_htmlFile
		close _htmlFile 
		
		shelllaunch _htmlPath ""
	)
	else messageBox "Please save this file before using RateIt!."
)

function getSnapshotRes =
(
	_resBmp = gw.getviewportDib()
	_resBmp = [_resBmp.width, _resBmp.height]
	_resBmp = (_resBmp/_resBmp[2])*200
	return _resBmp
)
