-- # Object management
function focusOn val =
(
	if itemsToRate.count > 0 then
	(
		updateCounter()
		obj = ItemsToRate[val]
		
		if (isValidNode obj) then
		(
			currentObject = obj
			
			with redraw off 
			(
				select obj			
				hide $* dolayer:false
				unhide obj
				max zoomext sel		
			)
			
			getCurrentObjectRating obj			
			
			redrawViews()
		)
	)
)

function updateCounter =
(
	rlt_RateIt.lbl_counter.text = (itemIndex as string + "/" + ItemsToRate.count as string)
)

function getItemsToRate =
(
	if selection.count > 0 then
	(
		ItemsToRate = for obj in selection where (isvalidnode obj) and superclassof obj == GeometryClass collect obj
		updateCounter()
		for obj in ItemsToRate do setTransformLockFlags obj #all -- verouille les objets
		max select -- passe en mode selection
		deselect $*
		return true
	)
	else return false
)	

function nextItem =
(
	itemIndex +=1
	if itemIndex > ItemsToRate.count then itemIndex = ItemsToRate.count
	focusOn itemIndex
)

function previousItem =
(
	itemIndex -=1
	if itemIndex < 1 then itemIndex = 1
	focusOn itemIndex
)